/*
  Remove Same Effect
    (C) あかつきみさき(みくちぃP)
    http://sunrisemoon.net/

  このスクリプトについて
    最後に選択したエフェクトと同じエフェクトを,アクティブなコンポジションから削除するスクリプト.

  使用方法
    1.ファイル→スクリプト→スクリプトファイルの実行から実行.

  動作環境
    Adobe After Effects 2022以上

  配布元
    http://sunrisemoon.net/

  バージョン情報
    2023/08/28 Ver 1.0.0 Release
*/

/// <reference path="D:\lib\aftereffects.d.ts\ae.d.ts"/>

(function () {
    var actComp = app.project.activeItem;
    if (actComp == null || !(actComp instanceof CompItem)) {
        alert("Select Effect", "Remove Same Effect");
        return 0;
    }

    var selLayers = actComp.selectedLayers;
    if (selLayers.length == 0) {
        alert("Select Effect", "Remove Same Effect");
        return 0;
    }

    var selLayer = selLayers[selLayers.length - 1];
    var selPros = selLayer.selectedProperties;
    if (selPros.length == 0) {
        alert("Select Effect", "Remove Same Effect");
        return 0;
    }

    var selPro = selPros[selPros.length - 1];
    var targetEffectMatchName = null;
    var tempPro = selPro;
    while (tempPro != null) {
        if (tempPro.parentProperty == null) {
            alert("Select Effect", "Remove Same Effect");
            return 0;
        }

        targetEffectMatchName = tempPro.matchName;

        if (tempPro.parentProperty.matchName != "ADBE Effect Parade") {
            tempPro = tempPro.parentProperty;
        } else {
            break;
        }
    }

    if (tempPro.parentProperty.matchName != "ADBE Effect Parade") {
        alert("Select Effect", "Remove Same Effect");
        return 0;
    }

    app.beginUndoGroup("Remove Same Effect");
    for (var i = 1; i <= actComp.layers.length; i++) {
        var curFx = actComp.layer(i).property("ADBE Effect Parade");
        if (curFx == null) {
            continue;
        }

        for (var j = curFx.numProperties; j >= 1; j--) {
            if (curFx.property(j).matchName != targetEffectMatchName) {
                continue;
            }

            curFx.property(j).remove();
        }
    }
    app.endUndoGroup();

    return 0;
}).call(this);
